package cn.estsh.i3plus.core.api.iservice.busi;


import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;
import cn.estsh.impp.framework.base.service.ICrudService;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 系统功能业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 15:18:14.958
 * @Modify      :
 **/
public interface ISysMenuService extends ICrudService<SysMenu> {


    @ApiOperation(value = "功能权限检查",notes = "功能权限检查(权限代码)")
    void checkSysMenuOnly(SysMenu bean);

    @ApiOperation(value = "更新内存语言缓存",notes = "更新内存语言缓存")
    void refreshMemSysMenuLanguage();

    @ApiOperation(value = "国际化功能权限",notes = "国际化功能权限")
    List<SysMenu> setLanguageSysMenuName(String languageCode, List<SysMenu> menuList);

    //    @Override
//    @ApiOperation(value = "更新菜单信息")
//    public void updateSysMenu(SysMenu menu) {
//        LOGGER.info("系统功能 SYS_MENU :{}", menu);
//
//        // 唯一校验 CODE 相同 ID 不同 则视为相同
//        StringBuffer countWhere = new StringBuffer();
//
//        HqlPack.getStringEqualPack( menu.getMenuCode(),"menuCode",countWhere);
//        HqlPack.getNumNOEqualPack(menu.getId().toString(),"id",countWhere);
//
//        int count = sysMenuRDao.findByHqlWhereCount(countWhere.toString());
//        if(count > 0){
//            throw ImppExceptionBuilder.newInstance()
//                    .setSystemID(CommonEnumUtil.SOFT_TYPE.CORE.getCode())
//                    .setErrorCode(ImppExceptionEnum.IO_EXCEPTION.getCode())
//                    .setErrorDetail("权限代码已存在")
//                    .setErrorSolution("请重新输入权限代码")
//                    .build();
//        }
//
//        // 父节点检查
//        coreTreeService.doValidatorSysMenuParentId(menu);
//
//        if (menu.getParentId() != null  && menu.getParentId() > 0) {
//            SysMenu parent = sysMenuRDao.getById(menu.getParentId());
//            ValidatorBean.checkNotNull(parent,"上级权限信息不存在");
//            menu.setParentNameRdd(parent.getName());
//        }
//
//        sysMenuRDao.update(menu);
//        // 更新冗余信息
//        updateSysMenuChildRdd(menu);
//    }
//
    @ApiOperation(value = "更新菜单信息",notes = "根据ID 更新菜单状态信息")
    void updateSysMenuStatus(Long id, int status, SessionUser user);

    @ApiOperation(value = "根据菜单代码查询菜单信息")
    SysMenu getSysMenuByCode(String code);

}
