package cn.estsh.i3plus.core.apiservice.configuration;

import cn.estsh.i3plus.core.api.iservice.base.IDataSeparatorService;
import cn.estsh.impp.framework.boot.init.IAppStartSystemInit;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2021/12/7 15:35
 * @Modify:
 **/

@Slf4j
@Component
public class DataSeparatorInit implements IAppStartSystemInit {

    @Autowired
    private IDataSeparatorService dataSeparatorService;

    @Override
    public void systemInit() {
        try {
            log.info("【通用数据冷热分离初始化开始...】");
            dataSeparatorService.separatorRedisInit();
            log.info("【通用数据冷热分离初始化结束...】");
        } catch (Exception e) {
            log.error("【通用数据冷热分离初始化失败】,失败原因:{}", e.getMessage());
        }
    }
}
